<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_06) on Wed Aug 20 17:16:46 PDT 2008 -->
<TITLE>
ReferenceMap (Google Collections Library - snapshot-20080820 (ALPHA))
</TITLE>

<META NAME="keywords" CONTENT="com.google.common.collect.ReferenceMap class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="ReferenceMap (Google Collections Library - snapshot-20080820 (ALPHA))";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/collect/PrimitiveArrays.html" title="class in com.google.common.collect"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/collect/Serialization.html" title="class in com.google.common.collect"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/ReferenceMap.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ReferenceMap.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
com.google.common.collect</FONT>
<BR>
Class ReferenceMap&lt;K,V&gt;</H2>
<PRE>
<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">java.util.AbstractMap</A>&lt;K,V&gt;
      <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>com.google.common.collect.ReferenceMap&lt;K,V&gt;</B>
</PRE>
<DL>
<DT><B>All Implemented Interfaces:</B> <DD><A HREF="http://java.sun.com/javase/6/docs/api/java/io/Serializable.html" title="class or interface in java.io">Serializable</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html" title="class or interface in java.util.concurrent">ConcurrentMap</A>&lt;K,V&gt;, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;K,V&gt;</DD>
</DL>
<HR>
<DL>
<DT><PRE>public final class <B>ReferenceMap&lt;K,V&gt;</B><DT>extends <A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;K,V&gt;<DT>implements <A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html" title="class or interface in java.util.concurrent">ConcurrentMap</A>&lt;K,V&gt;, <A HREF="http://java.sun.com/javase/6/docs/api/java/io/Serializable.html" title="class or interface in java.io">Serializable</A></DL>
</PRE>

<P>
A <code>ConcurrentMap</code> implementation that internally utilizes your choice
 of strong, soft or weak references for its keys and for its values. As soon
 as any key or value is reclaimed by the garbage collector, the corresponding
 entry automatically disappears from the map.

 <p>All nine possible combinations of reference types are supported, although
 using strong keys with strong values provides no benefit over using a <code>Map</code> or <code>ConcurrentMap</code> directly. This implementation does not permit
 null keys or values.

 <p><b>Note:</b> because garbage collection happens concurrently to your
 program, it follows that this map is always subject to concurrent
 modifications, whether or not the caller exposes it to multiple application
 threads. The usual caveats about the reliability of methods such as <A HREF="../../../../com/google/common/collect/ReferenceMap.html#size()"><CODE>size()</CODE></A> and <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#equals(java.lang.Object)" title="class or interface in java.util"><CODE>Map.equals(java.lang.Object)</CODE></A> apply; for example, <A HREF="../../../../com/google/common/collect/ReferenceMap.html#size()"><CODE>size()</CODE></A> may be
 observed to remain unchanged for a short time after an entry was reclaimed.

 <p>To determine equality to a key, this implementation uses
 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang"><CODE>Object.equals(java.lang.Object)</CODE></A> for strong references, and identity-based equality for
 soft and weak references. In other words, for a map with weak or soft key
 references, <A HREF="../../../../com/google/common/collect/ReferenceMap.html#get(java.lang.Object)"><CODE>get(java.lang.Object)</CODE></A> returns <code>null</code> when passed an object that
 equals a map key, but isn't the same instance. This behavior is similar to
 the way <A HREF="http://java.sun.com/javase/6/docs/api/java/util/IdentityHashMap.html" title="class or interface in java.util"><CODE>IdentityHashMap</CODE></A> handles key lookups. However, to determine
 value equality, as occurs when <A HREF="../../../../com/google/common/collect/ReferenceMap.html#containsValue(java.lang.Object)"><CODE>containsValue(java.lang.Object)</CODE></A> is called, the
 <code>ReferenceMap</code> always uses <code>equals</code>, regardless of the value
 reference type.

 <p><b>Note:</b> <code>new ReferenceMap(WEAK, STRONG)</code> is very nearly a
 drop-in replacement for <A HREF="http://java.sun.com/javase/6/docs/api/java/util/WeakHashMap.html" title="class or interface in java.util"><CODE>WeakHashMap</CODE></A>, but improves upon this by using
 only identity-based equality for keys. When possible, <code>ReferenceMap</code>
 should be preferred over the JDK collection, for its concurrency and greater
 flexibility.

 <p>Though this class implements <A HREF="http://java.sun.com/javase/6/docs/api/java/io/Serializable.html" title="class or interface in java.io"><CODE>Serializable</CODE></A>, serializing reference
 maps with weak or soft references leads to unpredictable results.
<P>

<P>
<DL>
<DT><B>Author:</B></DT>
  <DD>Bob Lee, Kevin Bourrillion</DD>
<DT><B>See Also:</B><DD><A HREF="../../../../serialized-form.html#com.google.common.collect.ReferenceMap">Serialized Form</A></DL>
<HR>

<P>
<!-- ======== NESTED CLASS SUMMARY ======== -->

<A NAME="nested_class_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Nested Class Summary</B></FONT></TH>
</TR>
</TABLE>
&nbsp;<A NAME="nested_classes_inherited_from_class_java.util.Map"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Nested classes/interfaces inherited from interface java.util.<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.Entry.html" title="class or interface in java.util">Map.Entry</A>&lt;<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.Entry.html" title="class or interface in java.util">K</A>,<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.Entry.html" title="class or interface in java.util">V</A>&gt;</CODE></TD>
</TR>
</TABLE>
&nbsp;

<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#ReferenceMap(com.google.common.base.ReferenceType, com.google.common.base.ReferenceType)">ReferenceMap</A></B>(<A HREF="../../../../com/google/common/base/ReferenceType.html" title="enum in com.google.common.base">ReferenceType</A>&nbsp;keyReferenceType,
             <A HREF="../../../../com/google/common/base/ReferenceType.html" title="enum in com.google.common.base">ReferenceType</A>&nbsp;valueReferenceType)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Constructs an empty instance, using the given reference types for keys and
 values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#ReferenceMap(com.google.common.base.ReferenceType, com.google.common.base.ReferenceType, java.util.concurrent.ConcurrentMap)">ReferenceMap</A></B>(<A HREF="../../../../com/google/common/base/ReferenceType.html" title="enum in com.google.common.base">ReferenceType</A>&nbsp;keyReferenceType,
             <A HREF="../../../../com/google/common/base/ReferenceType.html" title="enum in com.google.common.base">ReferenceType</A>&nbsp;valueReferenceType,
             <A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html" title="class or interface in java.util.concurrent">ConcurrentMap</A>&lt;<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>,<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&gt;&nbsp;backingMap)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Constructs an empty instance, using the given backing map and the given
 reference types for keys and values.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#clear()">clear</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Removes all of the mappings from this map.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#containsKey(java.lang.Object)">containsKey</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;key)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns <code>true</code> if this map contains a mapping for the specified key.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#containsValue(java.lang.Object)">containsValue</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;value)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns <code>true</code> if this map maps one or more keys to the specified
 value.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util">Set</A>&lt;<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.Entry.html" title="class or interface in java.util">Map.Entry</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#entrySet()">entrySet</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a set view of the mappings contained in this map.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#get(java.lang.Object)">get</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;key)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the value to which the specified key is mapped, or <code>null</code> if
 this map contains no mapping for the key.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#isEmpty()">isEmpty</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns <code>true</code> if this map contains no key-value mappings.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#put(K, V)">put</A></B>(<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>&nbsp;key,
    <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;value)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Associates the specified value with the specified key in this map.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#putIfAbsent(K, V)">putIfAbsent</A></B>(<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>&nbsp;key,
            <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;value)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;If the specified key is not already associated
 with a value, associate it with the given value.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#remove(java.lang.Object)">remove</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;key)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Removes the mapping for a key from this map if it is present.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#remove(java.lang.Object, java.lang.Object)">remove</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;key,
       <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;value)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Remove entry for key only if currently mapped to given value.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#replace(K, V)">replace</A></B>(<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>&nbsp;key,
        <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;value)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Replace entry for key only if currently mapped to some value.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#replace(K, V, V)">replace</A></B>(<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>&nbsp;key,
        <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;oldValue,
        <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;newValue)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Replace entry for key only if currently mapped to given value.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html#size()">size</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the number of key-value mappings in this map.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.util.AbstractMap"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.util.<A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#clone()" title="class or interface in java.util">clone</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#equals(java.lang.Object)" title="class or interface in java.util">equals</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#hashCode()" title="class or interface in java.util">hashCode</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#keySet()" title="class or interface in java.util">keySet</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#putAll(java.util.Map)" title="class or interface in java.util">putAll</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#toString()" title="class or interface in java.util">toString</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#values()" title="class or interface in java.util">values</A></CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.util.Map"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from interface java.util.<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#equals(java.lang.Object)" title="class or interface in java.util">equals</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#hashCode()" title="class or interface in java.util">hashCode</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#keySet()" title="class or interface in java.util">keySet</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#putAll(java.util.Map)" title="class or interface in java.util">putAll</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#values()" title="class or interface in java.util">values</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="ReferenceMap(com.google.common.base.ReferenceType, com.google.common.base.ReferenceType)"><!-- --></A><H3>
ReferenceMap</H3>
<PRE>
public <B>ReferenceMap</B>(<A HREF="../../../../com/google/common/base/ReferenceType.html" title="enum in com.google.common.base">ReferenceType</A>&nbsp;keyReferenceType,
                    <A HREF="../../../../com/google/common/base/ReferenceType.html" title="enum in com.google.common.base">ReferenceType</A>&nbsp;valueReferenceType)</PRE>
<DL>
<DD>Constructs an empty instance, using the given reference types for keys and
 values.
<P>
</DL>
<HR>

<A NAME="ReferenceMap(com.google.common.base.ReferenceType, com.google.common.base.ReferenceType, java.util.concurrent.ConcurrentMap)"><!-- --></A><H3>
ReferenceMap</H3>
<PRE>
public <B>ReferenceMap</B>(<A HREF="../../../../com/google/common/base/ReferenceType.html" title="enum in com.google.common.base">ReferenceType</A>&nbsp;keyReferenceType,
                    <A HREF="../../../../com/google/common/base/ReferenceType.html" title="enum in com.google.common.base">ReferenceType</A>&nbsp;valueReferenceType,
                    <A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html" title="class or interface in java.util.concurrent">ConcurrentMap</A>&lt;<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>,<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&gt;&nbsp;backingMap)</PRE>
<DL>
<DD>Constructs an empty instance, using the given backing map and the given
 reference types for keys and values.
<P>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="size()"><!-- --></A><H3>
size</H3>
<PRE>
public int <B>size</B>()</PRE>
<DL>
<DD>Returns the number of key-value mappings in this map.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#size()" title="class or interface in java.util">size</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#size()" title="class or interface in java.util">size</A></CODE> in class <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the number of key-value mappings in this map.</DL>
</DD>
</DL>
<HR>

<A NAME="isEmpty()"><!-- --></A><H3>
isEmpty</H3>
<PRE>
public boolean <B>isEmpty</B>()</PRE>
<DL>
<DD>Returns <code>true</code> if this map contains no key-value mappings.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#isEmpty()" title="class or interface in java.util">isEmpty</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#isEmpty()" title="class or interface in java.util">isEmpty</A></CODE> in class <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD><tt>true</tt> if this map contains no key-value mappings.</DL>
</DD>
</DL>
<HR>

<A NAME="containsKey(java.lang.Object)"><!-- --></A><H3>
containsKey</H3>
<PRE>
public boolean <B>containsKey</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;key)</PRE>
<DL>
<DD>Returns <code>true</code> if this map contains a mapping for the specified key.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#containsKey(java.lang.Object)" title="class or interface in java.util">containsKey</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#containsKey(java.lang.Object)" title="class or interface in java.util">containsKey</A></CODE> in class <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>key</CODE> - key whose presence in this map is to be tested.
<DT><B>Returns:</B><DD><tt>true</tt> if this map contains a mapping for the specified
            key.</DL>
</DD>
</DL>
<HR>

<A NAME="containsValue(java.lang.Object)"><!-- --></A><H3>
containsValue</H3>
<PRE>
public boolean <B>containsValue</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;value)</PRE>
<DL>
<DD>Returns <code>true</code> if this map maps one or more keys to the specified
 value.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#containsValue(java.lang.Object)" title="class or interface in java.util">containsValue</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#containsValue(java.lang.Object)" title="class or interface in java.util">containsValue</A></CODE> in class <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>value</CODE> - value whose presence in this map is to be tested.
<DT><B>Returns:</B><DD><tt>true</tt> if this map maps one or more keys to this value.</DL>
</DD>
</DL>
<HR>

<A NAME="get(java.lang.Object)"><!-- --></A><H3>
get</H3>
<PRE>
public <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A> <B>get</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;key)</PRE>
<DL>
<DD>Returns the value to which the specified key is mapped, or <code>null</code> if
 this map contains no mapping for the key.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#get(java.lang.Object)" title="class or interface in java.util">get</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#get(java.lang.Object)" title="class or interface in java.util">get</A></CODE> in class <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>key</CODE> - key whose associated value is to be returned.
<DT><B>Returns:</B><DD>the value to which this map maps the specified key.<DT><B>See Also:</B><DD><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#containsKey(java.lang.Object)" title="class or interface in java.util"><CODE>AbstractMap.containsKey(Object)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="put(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="put(K, V)"><!-- --></A><H3>
put</H3>
<PRE>
public <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A> <B>put</B>(<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>&nbsp;key,
             <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;value)</PRE>
<DL>
<DD>Associates the specified value with the specified key in this map.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#put(K, V)" title="class or interface in java.util">put</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#put(K, V)" title="class or interface in java.util">put</A></CODE> in class <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>key</CODE> - key with which the specified value is to be associated.<DD><CODE>value</CODE> - value to be associated with the specified key.
<DT><B>Returns:</B><DD>previous value associated with specified key, or <tt>null</tt>
               if there was no mapping for key.  (A <tt>null</tt> return can
               also indicate that the map previously associated <tt>null</tt>
               with the specified key, if the implementation supports
               <tt>null</tt> values.)</DL>
</DD>
</DL>
<HR>

<A NAME="putIfAbsent(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="putIfAbsent(K, V)"><!-- --></A><H3>
putIfAbsent</H3>
<PRE>
public <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A> <B>putIfAbsent</B>(<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>&nbsp;key,
                     <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;value)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html#putIfAbsent(K, V)" title="class or interface in java.util.concurrent">java.util.concurrent.ConcurrentMap</A></CODE></B></DD>
<DD>If the specified key is not already associated
 with a value, associate it with the given value.
 This is equivalent to
 <pre>
   if (!map.containsKey(key))
      return map.put(key, value);
   else
      return map.get(key);
 </pre>
 Except that the action is performed atomically.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html#putIfAbsent(K, V)" title="class or interface in java.util.concurrent">putIfAbsent</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html" title="class or interface in java.util.concurrent">ConcurrentMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>key</CODE> - key with which the specified value is to be associated.<DD><CODE>value</CODE> - value to be associated with the specified key.
<DT><B>Returns:</B><DD>previous value associated with specified key, or <tt>null</tt>
         if there was no mapping for key.  A <tt>null</tt> return can
         also indicate that the map previously associated <tt>null</tt>
         with the specified key, if the implementation supports
         <tt>null</tt> values.</DL>
</DD>
</DL>
<HR>

<A NAME="replace(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="replace(K, V)"><!-- --></A><H3>
replace</H3>
<PRE>
public <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A> <B>replace</B>(<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>&nbsp;key,
                 <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;value)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html#replace(K, V)" title="class or interface in java.util.concurrent">java.util.concurrent.ConcurrentMap</A></CODE></B></DD>
<DD>Replace entry for key only if currently mapped to some value.
 Acts as
 <pre>
  if ((map.containsKey(key)) {
     return map.put(key, value);
 } else return null;
 </pre>
 except that the action is performed atomically.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html#replace(K, V)" title="class or interface in java.util.concurrent">replace</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html" title="class or interface in java.util.concurrent">ConcurrentMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>key</CODE> - key with which the specified value is associated.<DD><CODE>value</CODE> - value to be associated with the specified key.
<DT><B>Returns:</B><DD>previous value associated with specified key, or <tt>null</tt>
         if there was no mapping for key.  A <tt>null</tt> return can
         also indicate that the map previously associated <tt>null</tt>
         with the specified key, if the implementation supports
         <tt>null</tt> values.</DL>
</DD>
</DL>
<HR>

<A NAME="replace(java.lang.Object,java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="replace(K, V, V)"><!-- --></A><H3>
replace</H3>
<PRE>
public boolean <B>replace</B>(<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>&nbsp;key,
                       <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;oldValue,
                       <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&nbsp;newValue)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html#replace(K, V, V)" title="class or interface in java.util.concurrent">java.util.concurrent.ConcurrentMap</A></CODE></B></DD>
<DD>Replace entry for key only if currently mapped to given value.
 Acts as
 <pre>
  if ((map.containsKey(key) && map.get(key).equals(oldValue)) {
     map.put(key, newValue);
     return true;
 } else return false;
 </pre>
 except that the action is performed atomically.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html#replace(K, V, V)" title="class or interface in java.util.concurrent">replace</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html" title="class or interface in java.util.concurrent">ConcurrentMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>key</CODE> - key with which the specified value is associated.<DD><CODE>oldValue</CODE> - value expected to be associated with the specified key.<DD><CODE>newValue</CODE> - value to be associated with the specified key.
<DT><B>Returns:</B><DD>true if the value was replaced</DL>
</DD>
</DL>
<HR>

<A NAME="remove(java.lang.Object)"><!-- --></A><H3>
remove</H3>
<PRE>
public <A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A> <B>remove</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;key)</PRE>
<DL>
<DD>Removes the mapping for a key from this map if it is present.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#remove(java.lang.Object)" title="class or interface in java.util">remove</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#remove(java.lang.Object)" title="class or interface in java.util">remove</A></CODE> in class <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>key</CODE> - key whose mapping is to be removed from the map.
<DT><B>Returns:</B><DD>previous value associated with specified key, or <tt>null</tt>
               if there was no entry for key.  (A <tt>null</tt> return can
               also indicate that the map previously associated <tt>null</tt>
               with the specified key, if the implementation supports
               <tt>null</tt> values.)</DL>
</DD>
</DL>
<HR>

<A NAME="remove(java.lang.Object, java.lang.Object)"><!-- --></A><H3>
remove</H3>
<PRE>
public boolean <B>remove</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;key,
                      <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;value)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html#remove(java.lang.Object, java.lang.Object)" title="class or interface in java.util.concurrent">java.util.concurrent.ConcurrentMap</A></CODE></B></DD>
<DD>Remove entry for key only if currently mapped to given value.
 Acts as
 <pre>
  if ((map.containsKey(key) && map.get(key).equals(value)) {
     map.remove(key);
     return true;
 } else return false;
 </pre>
 except that the action is performed atomically.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html#remove(java.lang.Object, java.lang.Object)" title="class or interface in java.util.concurrent">remove</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/ConcurrentMap.html" title="class or interface in java.util.concurrent">ConcurrentMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>key</CODE> - key with which the specified value is associated.<DD><CODE>value</CODE> - value associated with the specified key.
<DT><B>Returns:</B><DD>true if the value was removed, false otherwise</DL>
</DD>
</DL>
<HR>

<A NAME="clear()"><!-- --></A><H3>
clear</H3>
<PRE>
public void <B>clear</B>()</PRE>
<DL>
<DD>Removes all of the mappings from this map.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#clear()" title="class or interface in java.util">clear</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#clear()" title="class or interface in java.util">clear</A></CODE> in class <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="entrySet()"><!-- --></A><H3>
entrySet</H3>
<PRE>
public <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util">Set</A>&lt;<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.Entry.html" title="class or interface in java.util">Map.Entry</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;&gt; <B>entrySet</B>()</PRE>
<DL>
<DD>Returns a set view of the mappings contained in this map.  Each element
 in this set is a Map.Entry.  The set is backed by the map, so changes
 to the map are reflected in the set, and vice-versa.  (If the map is
 modified while an iteration over the set is in progress, the results of
 the iteration are undefined.)  The set supports element removal, which
 removes the corresponding entry from the map, via the
 <tt>Iterator.remove</tt>, <tt>Set.remove</tt>, <tt>removeAll</tt>,
 <tt>retainAll</tt> and <tt>clear</tt> operations.  It does not support
 the <tt>add</tt> or <tt>addAll</tt> operations.

 <p><b>Note:</b> Regardless of the choice of key and value reference types,
 an entry in the entry set always has strong references to both key and
 value. You should avoid any lingering strong references to <code>Entry</code>
 objects.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html#entrySet()" title="class or interface in java.util">entrySet</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE><DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html#entrySet()" title="class or interface in java.util">entrySet</A></CODE> in class <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractMap.html" title="class or interface in java.util">AbstractMap</A>&lt;<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">K</A>,<A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="type parameter in ReferenceMap">V</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>a set view of the mappings contained in this map.</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/collect/PrimitiveArrays.html" title="class in com.google.common.collect"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/collect/Serialization.html" title="class in com.google.common.collect"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/ReferenceMap.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ReferenceMap.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
